/*	imheader - Text Input Method Header
 *
 *  standard_key.h - 
 *
 *	Authors: YE Nan <nan.ye@orange-ftgourp.com>,
 *           LUO Lei <Srella@163.com>
 *
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef __PTIM_STANDARD_KEY_H
#define __PTIM_STANDARD_KEY_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * TTY Functions, cleverly chosen to map to ascii, for convenience of
 * programming, but could have been arbitrary (at the cost of lookup
 * tables in client code.
 */

#define IME_KEY_BackSpace		0xFF08    /* back space, back char */
#define IME_KEY_Tab				0xFF09
#define IME_KEY_Linefeed		0xFF0A    /* Linefeed, LF */
#define IME_KEY_Clear			0xFF0B
#define IME_KEY_Return			0xFF0D    /* Return, enter */
#define IME_KEY_Pause			0xFF13    /* Pause, hold */
#define IME_KEY_Scroll_Lock		0xFF14
#define IME_KEY_Sys_Req			0xFF15
#define IME_KEY_Escape			0xFF1B
#define IME_KEY_Delete			0xFFFF    /* Delete, rubout */

/* Cursor control & motion */

#define IME_KEY_Home			0xFF50
#define IME_KEY_Left			0xFF51    /* Move left, left arrow */
#define IME_KEY_Up				0xFF52    /* Move up, up arrow */
#define IME_KEY_Right			0xFF53    /* Move right, right arrow */
#define IME_KEY_Down			0xFF54    /* Move down, down arrow */
#define IME_KEY_Prior			0xFF55    /* Prior, previous */
#define IME_KEY_Page_Up			0xFF55
#define IME_KEY_Next			0xFF56    /* Next */
#define IME_KEY_Page_Down		0xFF56
#define IME_KEY_End				0xFF57    /* EOL */
#define IME_KEY_Begin 			0xFF58    /* BOL */

#define IME_KEY_space			0x020
#define IME_KEY_exclam			0x021
#define IME_KEY_quotedbl		0x022
#define IME_KEY_numbersign		0x023
#define IME_KEY_dollar			0x024
#define IME_KEY_percent			0x025
#define IME_KEY_ampersand		0x026
#define IME_KEY_apostrophe		0x027
#define IME_KEY_quoteright		0x027    /* deprecated */
#define IME_KEY_parenleft		0x028
#define IME_KEY_parenright		0x029
#define IME_KEY_asterisk		0x02a
#define IME_KEY_plus			0x02b
#define IME_KEY_comma			0x02c
#define IME_KEY_minus			0x02d
#define IME_KEY_period			0x02e
#define IME_KEY_slash			0x02f

#define IME_KEY_0				0x030
#define IME_KEY_1				0x031
#define IME_KEY_2				0x032
#define IME_KEY_3				0x033
#define IME_KEY_4				0x034
#define IME_KEY_5				0x035
#define IME_KEY_6				0x036
#define IME_KEY_7				0x037
#define IME_KEY_8				0x038
#define IME_KEY_9				0x039

#define IME_KEY_colon			0x03a
#define IME_KEY_semicolon		0x03b
#define IME_KEY_less			0x03c
#define IME_KEY_equal			0x03d
#define IME_KEY_greater			0x03e
#define IME_KEY_question		0x03f
#define IME_KEY_at				0x040

#define IME_KEY_A				0x041
#define IME_KEY_B				0x042
#define IME_KEY_C				0x043
#define IME_KEY_D				0x044
#define IME_KEY_E				0x045
#define IME_KEY_F				0x046
#define IME_KEY_G				0x047
#define IME_KEY_H				0x048
#define IME_KEY_I				0x049
#define IME_KEY_J				0x04a
#define IME_KEY_K				0x04b
#define IME_KEY_L				0x04c
#define IME_KEY_M				0x04d
#define IME_KEY_N				0x04e
#define IME_KEY_O				0x04f
#define IME_KEY_P				0x050
#define IME_KEY_Q				0x051
#define IME_KEY_R				0x052
#define IME_KEY_S				0x053
#define IME_KEY_T				0x054
#define IME_KEY_U				0x055
#define IME_KEY_V				0x056
#define IME_KEY_W				0x057
#define IME_KEY_X				0x058
#define IME_KEY_Y				0x059
#define IME_KEY_Z				0x05a

#define IME_KEY_bracketleft		0x05b
#define IME_KEY_backslash		0x05c
#define IME_KEY_bracketright	0x05d
#define IME_KEY_asciicircum		0x05e
#define IME_KEY_underscore		0x05f
#define IME_KEY_grave			0x060
#define IME_KEY_quoteleft		0x060    /* deprecated */

#define IME_KEY_a				0x061
#define IME_KEY_b				0x062
#define IME_KEY_c				0x063
#define IME_KEY_d				0x064
#define IME_KEY_e				0x065
#define IME_KEY_f				0x066
#define IME_KEY_g				0x067
#define IME_KEY_h				0x068
#define IME_KEY_i				0x069
#define IME_KEY_j				0x06a
#define IME_KEY_k				0x06b
#define IME_KEY_l				0x06c
#define IME_KEY_m				0x06d
#define IME_KEY_n				0x06e
#define IME_KEY_o				0x06f
#define IME_KEY_p				0x070
#define IME_KEY_q				0x071
#define IME_KEY_r				0x072
#define IME_KEY_s				0x073
#define IME_KEY_t				0x074
#define IME_KEY_u				0x075
#define IME_KEY_v				0x076
#define IME_KEY_w				0x077
#define IME_KEY_x				0x078
#define IME_KEY_y				0x079
#define IME_KEY_z				0x07a

#define IME_KEY_braceleft		0x07b
#define IME_KEY_bar				0x07c
#define IME_KEY_braceright		0x07d
#define IME_KEY_asciitilde		0x07e

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __PTIM_STANDARD_KEY_H */

/*
vi:ts=4:nowrap:ai:expandtab
*/
